<template>
    <div class="container">
        
        <h1 class="h1 margin-top">Receta </h1>
        <NuxtLink to="/recipies">&#60; Ver recetas.</NuxtLink>
        <div>
            <form @submit.prevent="submitForm">
                <table class="table" width="500px">
                    <tr>
                        <td width="150px">Descripción:</td>
                        <td>
                            <input type="text" name="nombre" v-model="recetaInfo.nombre" autocomplete="off" />
                        </td>
                    </tr>
                    <tr>
                        <td width="150px">Para:</td>
                        <td>
                            <select name="userId" id="userId" v-model="recetaInfo.user.id">
                                <option value="0">Seleccione</option>
                                <option :value="ui.id" v-for="(ui, _ui) in usersList" :key="_ui" >{{ ui.nombres }} {{ ui.apellidos }} ({{ ui.type }})</option>
                            </select>
                        </td>
                    </tr>
                    <tr>
                        <td width="150px">Para:</td>
                        <td>
                            <input type="text" v-model="recetaInfo.totalPrice" name="totalPrice" readonly />
                        </td>
                    </tr>
                </table>

                <table class="table table-hover table-bordered table-sm" width="500px">
                    <thead>
                        <tr>
                            <th class="text-center"></th>
                            <th class="text-center">Producto</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr v-for="(pitem, k) in recetaInfo.productos" :key="k">
                            <td class="text-center">
                                <input 
                                    type="checkbox"
                                    name="productIds[]"
                                    v-model="pitem.chk"
                                    :value="pitem.id"
                                    @change="updateTotalPrice($event)"
                                />
                            </td>
                            <td class="text-center">
                                {{ pitem.nombre }} (<small>{{ pitem.descripcion }}</small>)
                            </td>
                        </tr>
                    </tbody>
                </table>

                <div>
                    <input type="submit" class="btn btn-primary" :value="currentAction.name" />
                </div>
            </form>
        </div>

    </div>
</template>
<script lang="ts" setup>
import { baseActionDetection } from '~/server/utils/forms/actionsDetector';
import type { recipieType } from '~/server/utils/types/recipieType';

    const routerInstance = (useRouter());
    const id = ref(routerInstance.currentRoute.value.params.id.toString());
    let currentAction = ref(baseActionDetection(parseInt(id.value), routerInstance.currentRoute.value));

    async function detectProductList () {
        let pl: any = await $fetch('/api/product', {   
            method: 'GET',
            headers: { 'method': 'list' }
        });
        pl.map(function (p: any) {
            p.chk = false;
            return p;
        })
        return pl;
    }


    const recetaInfo:any = ref({
        id: 0,
        nombre: "",
        totalPrice: 0,
        productos: await detectProductList(),
        user: {
            id: 0
        }
    });


    let usersList:any = await $fetch('/api/user', {
        method: 'GET',
        headers: { 'method': 'list' }
    });

    function updateTotalPrice(ev:any) {
        let productosMarcados = recetaInfo.value.productos.filter((p: any) => p.chk).map((p: any) :number => parseFloat(p.precioUnitario));
        if (productosMarcados.length <= 0) {
            recetaInfo.value.totalPrice = 0;
            return;
        }
        recetaInfo.value.totalPrice = parseFloat(productosMarcados.reduce((acumulator:number, currentValue:number) => acumulator + currentValue, 0).toFixed(2));
    }

    if (currentAction.value.index !== 0) {
        findItemById(parseInt(id.value));
    }

    async function findItemById(id: number) {
        let r: any = await $fetch(`/api/recipie?id=${id}`, {   
            method: 'GET',
            headers: { 'method': 'findRecord' }
        });
        let productos = r.productos.map((p: any) => {
            return p.id;
        });
        r.productos = await detectProductList();
        r.productos = r.productos.map((_p: any) => {
            _p.chk = productos.includes(_p.id);
            return _p;
        })
        recetaInfo.value = r;
    }

    async function submitForm() {
        let r = await $fetch(`/api/recipie`, {   
            method: 'POST',
            body: recetaInfo.value,
            headers: { 'method': currentAction.value.method }
        });
        navigateTo('/recipies');
    }
</script>
